

var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};


function storeSubParameter(path, value) {
    Property.setProperty('/scripts/consumption-messenger/entries/' + path, value);
    Property.setFlag('/scripts/consumption-messenger/entries/' + path, 'ARCHIVE', true);
}

function getNewIdValue() {
    var idValue = new Date().getTime();
    var baseNode = Property.getNode('/scripts/consumption-messenger/entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function storeValue(sParameterString) {
    try {
        var oParameterObject = JSON.parse(unescape(sParameterString));


        var esName = "" + oParameterObject.dsuid;

        var baseNode = Property.getNode('/scripts/consumption-messenger/entries');
        if (baseNode != null)
            baseNode.removeChild(esName);
        
        storeSubParameter(esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter(esName + '/template', Utf8.encode(unescape(oParameterObject.template)));
        storeSubParameter(esName + '/dsuid', oParameterObject.dsuid);
        storeSubParameter(esName + '/recurrence', oParameterObject.recurrence);
        
        storeSubParameter(esName + '/conditions/enabled', true);
        Property.store();
    } catch (e) {
    	lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
        	lWarn.logln(i + ': ' + e[i]);
        }

    }
}

lInfo.logln("consumption-messenenger-Config " + raisedEvent.name);
if (raisedEvent.name == 'consumption-messenger') {
	Property.load();
	lInfo.logln("param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
    	lInfo.logln("param value " + raisedEvent.parameter.value);
        storeValue(raisedEvent.parameter.value);
        Property.store();
        var evt = new Event("consumption-messenenger.saved", {});
        evt.raise();
        scheduleAllElements();
    }  
    if (raisedEvent.parameter.actions == 'delete') {
    	lInfo.logln("delete value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        /*if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];*/

        for (var sKey in oIDObject) {
        	lInfo.logln('removing id ' + oIDObject[sKey]);
            var baseNode = Property.getNode('entries');
            if (baseNode != null)
                baseNode.removeChild(oIDObject[sKey]);        	
        }

        Property.store();
        var evt = new Event("consumption-messenenger.saved", {});
        evt.raise();
        scheduleAllElements();
    }
    
	if (raisedEvent.parameter.actions=='enable')
	{
	    lInfo.logln("enable value " + raisedEvent.parameter.id);	
	 
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
            var sanityCheck = Property.getNode('entries/' + oIDObject[sKey]);
            if (sanityCheck != null) {                
        	    storeSubParameter(oIDObject[sKey] + '/conditions/enabled', true);
        		Property.store();
            }
        }
        
		var evt = new Event("consumption-messenenger.saved",{});			
		evt.raise();
	}
	if (raisedEvent.parameter.actions=='disable')
	{
	    lInfo.logln("disable value " + raisedEvent.parameter.id);		

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
    	    var sanityCheck = Property.getNode('entries/' + oIDObject[sKey]);
            if (sanityCheck != null) {
        	    storeSubParameter(oIDObject[sKey] + '/conditions/enabled', false);
        		Property.store();
            }        	
        }
        var evt = new Event("consumption-messenenger.saved",{});			
		evt.raise();
	}	
    
} else if (raisedEvent.name == 'running') {
    Property.load();
    convertPropertyTreeEntries();
    scheduleAllElements();
}