var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};


var LOGFILE_NAME = "consumption-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function getAllDevices() {
	var oResult=[];
	var oParent=Property.getNode('entries');
	if (oParent==null) {
		lInfo.logln('no timers must be set');
		return [];
	}
	
	if (raisedEvent.parameter.type!=null)
	{
		var queue = oParent.getChildren();
		for ( var i = 0; i < queue.length; i++) { 
			if (queue[i].getChild('recurrence')!=null)
			{
				if (raisedEvent.parameter.type==(queue[i].getChild('recurrence').getValue())) {
					oResult.push(queue[i].getChild('dsuid').getValue());
				}
			}
	    }
	}
	
	return oResult;
} 

function storeParameter(path, value) {
    Property.setProperty('/scripts/consumption-messenger/entries/' + path, value);
    Property.setFlag('/scripts/consumption-messenger/entries/' + path, 'ARCHIVE', true);
}


function addLeadingZeroes(number, count) {
    var result = '' + number;
    while (result.length < count) {
        result = '0' + result;
    }
    return result;
}

function timeStamp() {
	var oDate = new Date();
	return oDate.getDate() + "." + (oDate.getMonth() + 1) + "."
			+ oDate.getFullYear() + " " + oDate.getHours() + ":"
			+ addLeadingZeroes(oDate.getMinutes(),2);
}

function sendValue(dSUID,value,deltaValue) {
	
	var sString="Gert " + dSUID + " Zhlerstand: " + value*0.01 + " delta: " + deltaValue*0.01;	
	var oTemplateNode=Property.getNode('entries/' + dSUID+'/template');
	if (oTemplateNode!=null) {
		sString=oTemplateNode.getValue();
		sString=sString.replace("%delta%", ""+deltaValue*0.01);
		sString=sString.replace("%sum%", ""+value*0.01);
		sString+= " #mydigitalstrom " + timeStamp();
	}
	lInfo.logln('sending ' + sString);
	new Event('event-twitterer',{actions:'send',message:Utf8.decode(sString)}).raise();
}

var oArray=getAllDevices();
for (var iIndex=0;iIndex<oArray.length;iIndex++) {
	var dSUID=oArray[iIndex];
	var oDSUIDNode=Property.getNode('entries/' + dSUID);
	var sensorIndex=4;
	lInfo.logln('Query Power for ' + dSUID);
	var value=getDevices().byDSUID(dSUID).getSensorValue(sensorIndex);
	lInfo.logln('got Power ' + value);
	var oldValue=value;
	if (oDSUIDNode.getChild('lastvalue')!=null)
		oldValue=oDSUIDNode.getChild('lastvalue').getValue();
	storeParameter(dSUID + '/lastvalue',value);
	storeParameter(dSUID + '/lastvaluetime',(new Date().getTime()));
	Property.store();
	
	sendValue(dSUID,value,(value-oldValue+4096)%4096);
}