var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "consumption-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

var sRRuleMinutly="FREQ=MINUTELY";
var sRRuleHourly="FREQ=HOURLY";
var sRRuleDaily="FREQ=DAILY";
var sRRuleWeekly="FREQ=WEEKLY";

function pad(c) {
    var i = parseInt(c, 10);
    return (i < 10 ? '0' + i : c.toString());
}

var dold = new Date();
dold.setTime(dold.getTime() - (1000 * 60 * 60 * 24 * 7));

var iCalStartTime=dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T000000';

function resetTimer() {
    lInfo.logln('resetTimers');
    var aOldNotes = Property.getNode('scheduledFixedEvents');
    if (aOldNotes != null) {
        lInfo.logln('resetTimers');
        var queue = aOldNotes.getChildren();
        for ( var i = 0; i < queue.length; ++i) {
            var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queue[i].getValue());
            if (propNode) {
                propNode.getParent().removeChild(propNode);
            }
            lInfo.logln('resetTimers - remove old #' + i);
        }
    }
    var aOldNotes = Property.getNode('/scripts/consumption-messenger');
    if (aOldNotes != null)
        aOldNotes.removeChild('scheduledFixedEvents' );
}

function scheduleAllElements() {
	resetTimer();
	lInfo.logln('ScheduleAllElements');
	var oParent=Property.getNode('entries');
	if (oParent==null) {
		lInfo.logln('no timers must be set');
		return;
	}
	var queue = oParent.getChildren();

	var fMinutely=false;
	var fHourly=false;
	var fDaily=false;
	var fWeekly=false;

	for ( var i = 0; i < queue.length; ++i) { 
		if (queue[i].getChild('recurrence')!=null)
		{
			switch (queue[i].getChild('recurrence').getValue()) {
			case '4':
				fMinutely=true;
				break;
			case '3':
				fHourly=true;
				break;
			case '2':
				fDaily=true;
				break;
			case '1':
				fWeekly=true;
				break;
			}
		}
    }
	if (fMinutely) {
		lInfo.logln('Setting minutly Timer');
        var timerEvent = new TimedICalEvent('consumption-messenger.timed-event', iCalStartTime, sRRuleMinutly, {
            type:"4"                           
        }); 
        Property.setProperty('scheduledFixedEvents/minutly', timerEvent.raise());
	}
	if (fHourly) {
		lInfo.logln('Setting hourly Timer');
        var timerEvent = new TimedICalEvent('consumption-messenger.timed-event', iCalStartTime, sRRuleHourly, {
            type:"3"                           
        }); 
        Property.setProperty('scheduledFixedEvents/hourly', timerEvent.raise());
	}
	if (fDaily) {
		lInfo.logln('Setting daily Timer');
        var timerEvent = new TimedICalEvent('consumption-messenger.timed-event', iCalStartTime, sRRuleDaily, {
            type:"2"                           
        }); 
        Property.setProperty('scheduledFixedEvents/daily', timerEvent.raise());
	}
	if (fWeekly) {
		lInfo.logln('Setting weekly Timer');
        var timerEvent = new TimedICalEvent('consumption-messenger.timed-event', iCalStartTime, sRRuleWeekly, {
            type:"1"                           
        }); 
        Property.setProperty('scheduledFixedEvents/weekly', timerEvent.raise());
	}
}